//-------------------------------------------------------------------//
//                         STEROWNIK AVR-USB
//						   Marcin Bieda 2008
//
//						   krokowy.c
//-------------------------------------------------------------------//

#include "krokowy.h"
#include <avr/io.h>
#include <inttypes.h>
#include "makra.h"

void krok_wave (uint8_t krok)
{
	if(krok==4) krok=0;
	if(krok>4) krok=3;
	PORT(KROK_PORT) &= ~KROK_MASKA;
	PORT(KROK_PORT) |= 1<<(krok+KROK_PIN);
}

void krok_full (uint8_t krok)
{
	if(krok==4) krok=0;
	if(krok>4) krok=3;
	PORT(KROK_PORT) &= ~KROK_MASKA;
	if(krok)
	{
		PORT(KROK_PORT) |= 1<<(krok+KROK_PIN) | 1<<(krok+KROK_PIN-1);
	}
	else
	{
		PORT(KROK_PORT) |= 1<<(KROK_PIN) | 1<<(KROK_PIN+4);
	}
}

void krok_half (uint8_t krok)
{
	if(krok==8) krok=0;
	if(krok>8) krok=7;
	const uint8_t half_tabl[]={1,3,2,6,4,12,8,9};
	PORT(KROK_PORT) &= ~KROK_MASKA;
	PORT(KROK_PORT) |= half_tabl[krok]<<KROK_PIN;
}

void krok (uint8_t *krok, uint8_t ster)
{
	if(ster==0)
	{
		if(*krok==4) *krok=0;
		if(*krok>4) *krok=3;
		PORT(KROK_PORT) &= ~KROK_MASKA;
		if(*krok)
		{
			PORT(KROK_PORT) |= 1<<(*krok+KROK_PIN) | 1<<(*krok+KROK_PIN-1);
		}
		else
		{
			PORT(KROK_PORT) |= 1<<(KROK_PIN) | 1<<(KROK_PIN+4);
		}
	}
	else if (ster==1)
	{
		if(*krok==8) *krok=0;
		if(*krok>8) *krok=7;
		const uint8_t half_tabl[]={1,3,2,6,4,12,8,9};
		PORT(KROK_PORT) &= ~KROK_MASKA;
		PORT(KROK_PORT) |= half_tabl[*krok]<<KROK_PIN;
	}
	else if (ster==2)
	{
		if(*krok==4) *krok=0;
		if(*krok>4) *krok=3;
		PORT(KROK_PORT) &= ~KROK_MASKA;
		PORT(KROK_PORT) |= 1<<(*krok+KROK_PIN);
	}
}
